Attribute VB_Name = "AutoClose"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' IPress (C) 2001,2002,2003 Estndard Lingstic S.L.
'   versi 1.1rev7
'   Concepte i diseny per Ricard Prez
'   Programat per Gerardo Garca
'   Tots els drets reservats.
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

Private Sub ZZZ_CloseComplementaryDocs()
  Dim family As String
  Dim tipo As Integer
  Dim win As Window
  Dim sourceDoc As Document
  Dim otherDoc As Document
  
  Set sourceDoc = ActiveDocument
  If IsObjectValid(ZZZ_bar_doc) Then
  If ZZZ_bar_doc = sourceDoc Then Set ZZZ_bar_doc = Nothing
  End If
  If ZZZ_IsMarked(ActiveDocument) Then
    ZZZ_DestruyeMarcas ActiveDocument, False
      ' Obtenemos el otro documento
    family = ZZZ_ObtenerFamily(ActiveDocument)
    tipo = ZZZ_ObtenerId(ActiveDocument)
    If tipo = ZZZ_IdSourceText Then
      Set otherDoc = ZZZ_EncuentraDoc(family, ZZZ_IdTargetText)
    Else
      Set otherDoc = ZZZ_EncuentraDoc(family, ZZZ_IdSourceText)
    End If
    If IsObjectValid(ZZZ_bar_doc) Then
      If ZZZ_bar_doc = otherDoc Then Set ZZZ_bar_doc = Nothing
    End If
    ZZZ_EliminaVarsDoc ActiveDocument
    ZZZ_DestruyeMarcas otherDoc, False
    ZZZ_EliminaVarsDoc otherDoc
      ' Miramos cuantas ventanas tiene el documento activo
      ' si es 1, entonces cerramos todas las traducciones
      ' en caso contrario solo cerramos la ventanita actual
    If sourceDoc.Windows.Count <= 1 Then
      On Error Resume Next
      otherDoc.Close
    Else
      On Error Resume Next
      ActiveWindow.Close
    End If
  End If
End Sub

Public Sub AutoClose()
  WordBasic.Disableautomacros 1
  ZZZ_Barra.ZZZ_generaIPressToolBar
  ZZZ_CloseComplementaryDocs
  WordBasic.Disableautomacros 0
End Sub

