Attribute VB_Name = "ZZZ_CpFormat"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' IPress (C) 2001,2002,2003 Estndard Lingstic S.L.
'   versi 1.1rev7
'   Concepte i diseny per Ricard Prez
'   Programat per Gerardo Garca
'   Tots els drets reservats.
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

Public Sub ZZZ_DoALittleCopyFormat(ByRef played_alive_doc As Document, _
                                   ByRef external_life_doc As Document, _
                                   ByRef begin_tag As Long)
  Dim end_tag As Long
  Dim ranjete1 As Range
  Dim ranjete2 As Range
  
  played_alive_doc.Activate
  ZZZ_Marcas.ZZZ_IrAMarca played_alive_doc, begin_tag
  end_tag = ZZZ_Synchro.ZZZ_nearestTagOnOneDirection(True, begin_tag)
  Set ranjete1 = ZZZ_ObtenerRangeMarcas(played_alive_doc, ZZZ_generaSubMarca(begin_tag), ZZZ_generaSubMarca(end_tag))
  ranjete1.Select
  Selection.CopyFormat
  ZZZ_Marcas.ZZZ_IrAMarca played_alive_doc, end_tag
  
  external_life_doc.Activate
  ZZZ_Marcas.ZZZ_IrAMarca external_life_doc, begin_tag
  end_tag = ZZZ_Synchro.ZZZ_nearestTagOnOneDirection(True, begin_tag)
  Set ranjete2 = ZZZ_ObtenerRangeMarcas(external_life_doc, ZZZ_generaSubMarca(begin_tag), ZZZ_generaSubMarca(end_tag))
  ranjete2.Select
  Selection.PasteFormat
  ZZZ_Marcas.ZZZ_IrAMarca external_life_doc, end_tag
  
  Set ranjete1 = Nothing
  Set ranjete2 = Nothing
End Sub

Public Sub ZZZ_CopyFormat()
  Dim ntag As Long
  Dim alien_life_family As String
  Dim played_alive_doc As Document
  Dim external_life_doc As Document
  
  If Documents.Count > 0 Then
    alien_life_family = ZZZ_ObtenerFamily(ActiveDocument)
    If ZZZ_CompruebaPar(alien_life_family) Then
        ' Pillamos el source y el target
      Set played_alive_doc = ZZZ_EncuentraSource(alien_life_family)
      Set external_life_doc = ZZZ_EncuentraTarget(alien_life_family)
        ' Buscamos la marca mas cercana
      ntag = ZZZ_nearestTag
        ' Comprobamos si es valida, y si lo es, empezamos a hacer el tontito
      If ntag >= 0 Then
        ZZZ_SetupWindows alien_life_family
        ZZZ_DoALittleCopyFormat played_alive_doc, external_life_doc, ntag
      End If
    Else
      MsgBox "El fitxer tradut no est carregat."
    End If
  End If
End Sub
