Attribute VB_Name = "ZZZ_IPressMayusculas"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' IPress (C) 2001,2002,2003 Estndard Lingstic S.L.
'   versi 1.1rev7
'   Concepte i diseny per Ricard Prez
'   Programat per Gerardo Garca
'   Tots els drets reservats.
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

Public Const ZZZ_IPMbotonGoTo = 1
Public Const ZZZ_IPMbotonNext = 2
Public Const ZZZ_IPMbotonPrev = 3
Public Const ZZZ_IPMbotonExit = 5

Public ZZZ_IPMXXX As Boolean
Public ZZZ_IPMleft As Long
Public ZZZ_IPMtop As Long
Public ZZZ_IPMwhatonchow As Boolean

Public Sub ZZZ_IPressMayus()
  Dim docFamily As String
  Dim docsrc As Document
  Dim docTrg As Document
  Dim tmpdoc As Document
  Dim docSrcStart As Long
  Dim docSrcEnd As Long
  Dim docTrgStart As Long
  Dim docTrgEnd As Long
  Dim fin As Boolean
  Dim tagnum As Long
  Dim tagnumb As Long
  Dim ActualDirection As Boolean
  
  Dim rngSrc As Range
  Dim rngTrg As Range
  
  ActualDirection = True ' Inicialmente buscamos hacia adelante!
  
  If Documents.Count > 0 Then
      ' Averiguamos a que familia pertenece el documento este
    docFamily = ZZZ_ObtenerFamily(ActiveDocument)
    
    If ((docFamily <> "") And (ZZZ_CompruebaPar(docFamily))) Then
        ' Obtenemos ambos documentos
      Set docsrc = ZZZ_EncuentraSource(docFamily)
      Set docTrg = ZZZ_EncuentraTarget(docFamily)
      Set tmpdoc = ActiveDocument
        ' Nos acordamos de su posicin
      docsrc.Activate
      docSrcStart = Selection.Start
      docSrcEnd = Selection.End
      docTrg.Activate
      docTrgStart = Selection.Start
      docTrgEnd = Selection.End
        
        ' Encontramos el tag mas cercano, lo identificamos y nos situamos en paralelo
      tmpdoc.Activate
      tagnum = ZZZ_nearestTag()
      
      ZZZ_IrAMarca docsrc, tagnum
      ZZZ_IrAMarca docTrg, tagnum
      
        ' Comenzamos a trastear en ellos
      fin = False
      Do
        docsrc.Activate
        Set rngSrc = Selection.Paragraphs.First.Range
        docTrg.Activate
        Set rngTrg = Selection.Paragraphs.First.Range
          ' Pillamos la coleccion de palabras en mayusculas
        Set ZZZ_IPressMayusculasWindow.colop = ZZZ_BuildUCaseTranslationList(docsrc, docTrg, rngSrc, rngTrg)
          ' configuramos un poco mas la ventana
        Set ZZZ_IPressMayusculasWindow.docsrc = docsrc
        Set ZZZ_IPressMayusculasWindow.docTrg = docTrg
        
          ' Si hemos obtenido una cantidad de palabras en mayusculas las procesamos
        If ZZZ_IPressMayusculasWindow.colop.Count > 0 Then
          ZZZ_IPressMayusculasWindow.Show
          If ZZZ_IPressMayusculasWindow.opcion = ZZZ_IPMbotonGoTo Then
              ' Avanzamos al siguiente parrafo
            If ZZZ_IPressMayusculasWindow.poss1 >= 0 And ZZZ_IPressMayusculasWindow.pose1 >= 0 Then
              docsrc.Activate
              Selection.Start = ZZZ_IPressMayusculasWindow.poss1
              Selection.End = ZZZ_IPressMayusculasWindow.pose1
            End If
            If ZZZ_IPressMayusculasWindow.poss2 >= 0 And ZZZ_IPressMayusculasWindow.pose2 >= 0 Then
              docTrg.Activate
              Selection.Start = ZZZ_IPressMayusculasWindow.poss2
              Selection.End = ZZZ_IPressMayusculasWindow.pose2
            End If
            If ZZZ_IPMwhatonchow Then
              docTrg.Activate
            Else
              docsrc.Activate
            End If
            fin = True
          ElseIf ZZZ_IPressMayusculasWindow.opcion = ZZZ_IPMbotonNext Then
            docsrc.Activate
            Selection.Start = rngSrc.Start
            Selection.Collapse
            tagnumb = ZZZ_nearestTagOnOneDirection(True, tagnum)
            ActualDirection = True  ' Ahora siempre buscaremos hacia adelante
            If tagnumb >= 0 Then
              tagnum = tagnumb
            End If
            ZZZ_IrAMarca docsrc, tagnum
            ZZZ_IrAMarca docTrg, tagnum
          ElseIf ZZZ_IPressMayusculasWindow.opcion = ZZZ_IPMbotonPrev Then
            docsrc.Activate
            Selection.Start = rngSrc.Start
            Selection.Collapse
            tagnumb = ZZZ_nearestTagOnOneDirection(False, tagnum)
            ActualDirection = False ' Ahora siempre buscaremos hacia atras
            If tagnumb >= 0 Then
              tagnum = tagnumb
            End If
            ZZZ_IrAMarca docsrc, tagnum
            ZZZ_IrAMarca docTrg, tagnum
          Else
            docsrc.Activate
            Selection.Start = docSrcStart
            Selection.End = docSrcEnd
            docTrg.Activate
            Selection.Start = docTrgStart
            Selection.End = docTrgEnd
            tmpdoc.Activate
            fin = True
          End If
          Set ZZZ_IPressMayusculasWindow = Nothing
        Else
          If MsgBox("Aquest pargraf no cont cap paraula en majscules. Avano al segent?", vbOKCancel) = vbOK Then
            docsrc.Activate
            Selection.Start = rngSrc.Start
            Selection.Collapse
                 ' NOTA: Buscamos en la ultima direccion usada
            tagnumb = ZZZ_nearestTagOnOneDirection(ActualDirection, tagnum)
            If tagnumb >= 0 Then
              tagnum = tagnumb
            End If
            ZZZ_IrAMarca docsrc, tagnum
            ZZZ_IrAMarca docTrg, tagnum
        Else
          fin = True
          End If
        End If
        Set ZZZ_IPressMayusculasWindow = Nothing
      Loop While Not fin
    Else
      MsgBox "Aquest document no est preparat per sser tractat amb aquest procediment."
    End If
  Else
    MsgBox "No hi ha cap document obert on treballar!", vbExclamation, "Atenci!"
  End If
End Sub
