Attribute VB_Name = "ZZZ_Save"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'
' IPress (C) 2001,2002,2003 Estndard Lingstic S.L.
'   versi 1.1rev7
'   Concepte i diseny per Ricard Prez
'   Programat per Gerardo Garca
'   Tots els drets reservats.
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

Public Sub ZZZ_Save()
  Dim mbret As Integer
  Dim startDoc As Document, otherDoc As Document
  On Error Resume Next
  
  If Documents.Count > 0 Then
    If ZZZ_IsMarked(ActiveDocument) Then
      ' Nos guardamos el documento desde donde nos llamaron
      Set startDoc = ActiveDocument
      ' Si el hermano est disponible hacemos una incisiva pregunta, en caso
      ' contrario podemos asegurar que el usuario no quiere que se graben los dos
      ' documentos, ya que slo hay uno!!
      If ZZZ_CompruebaPar(ZZZ_ObtenerFamily(startDoc)) Then
        mbret = MsgBox("Desitja salvar els canvis en els dos documents alhora?", vbYesNoCancel, "IPress: Salvar el/s document/s")
      Else
        mbret = vbNo
      End If
      ' Si no se ha cancelado la operacin vamos palante como los de all
      If mbret <> vbCancel Then
        ' Salvamos primero el documento que nos han dicho que salvemos primero
        ZZZ_Preparing.ZZZ_preparing_action = 2
        ZZZ_PreparingWindow.Show
        Set ZZZ_PreparingWindow = Nothing
        ' Si nos han pedido que salvemos el otro, vamos palante como los otros
        If mbret = vbYes Then
            ' Ponemos el otro documento como activo
          If ZZZ_ObtenerId(startDoc) = ZZZ_IdSourceText Then
            Set otherDoc = ZZZ_EncuentraTarget(ZZZ_ObtenerFamily(startDoc))
          Else
            Set otherDoc = ZZZ_EncuentraSource(ZZZ_ObtenerFamily(startDoc))
          End If
          otherDoc.Activate
          ' Lo salvamos con una metodologa bastante simetrica a la anterior
          ZZZ_Preparing.ZZZ_preparing_action = 2
          ZZZ_PreparingWindow.Show
          Set ZZZ_PreparingWindow = Nothing
          ' Reactivamos el antiguo
          startDoc.Activate
          ' liberamos memory
          Set otherDoc = Nothing
        End If
      End If
      Set startDoc = Nothing
    Else
      ActiveDocument.Save
    End If
  End If
End Sub

Public Function ZZZ_empiezaSave()
    ' Eliminamos todos los tags (vale un 5%)
  ZZZ_PreparingWindow.done = 0
  ZZZ_PreparingWindow.rel_total = 5
  ZZZ_PreparingWindow.cambia_label ActiveDocument.name, 0
  ZZZ_DestruyeMarcas ActiveDocument, False
  ZZZ_PreparingWindow.cambia_label ActiveDocument.name, 100
  
    ' Salvamos el documento (vale otro 5%)
  ZZZ_PreparingWindow.done = 5
  ZZZ_PreparingWindow.rel_total = 10
  ActiveDocument.Save
  
    ' Volvemos a poner los tags (vale un 90%)
  ZZZ_PreparingWindow.cambia_label ActiveDocument.name, 100
  ZZZ_PreparingWindow.done = 10
  ZZZ_PreparingWindow.rel_total = 90
  ZZZ_insertarMarcas ActiveDocument, True
  
    ' Decimos que se ha acabado todo
  ZZZ_PreparingWindow.fin_tareas
End Function
